
      PROGRAM MACH2

!***********************************************************************

!    gera tabela e visualiza resultados do escoamento MACH
 
!                                           ltima alterao: 18 Dez 97
!***********************************************************************
      use msflib
!***********************************************************************
 
      PARAMETER (   NV = 1004  )

!***********************************************************************
      IMPLICIT REAL*8(A-H,O-Z)
      DIMENSION Te(NV),Pe(NV),ae(NV),ue(NV)
      REAL*8 M(NV),mi,me
      logical chamada
      integer*4 int4
 
      chamada = systemqq('notepad mach2.d')
 
      OPEN(5,FILE='mach2.d',FORM='FORMATTED')
      OPEN(6,FILE='mach2.s',FORM='FORMATTED')
      OPEN(7,FILE='mach2.dat',FORM='FORMATTED')

      CALL DADOS(ni,mi,me,gama)

      dm = (me-mi)/(ni-1) 

 
      DO I = 1, NI

        m(i) = mi + (i-1)*dm 
        call PROPRI(gama,M(i),te(i),pe(i),ue(i),ae(i))
 
      end do


  111 format(5(1pe10.3))

      write(6,113)
  113 format(//,t2,'Mach',t12,'A / At',t22,'T / T*',t32,'p / p*',  &
                          t42,'u / u*',/)
      do i=1,ni
        write(6,111) m(i),ae(i),te(i),pe(i),ue(i)
        write(7,111) m(i),ae(i),te(i),pe(i),ue(i)
      end do
      close(7)

      CLOSE(5)
      CLOSE(6)
 
      chamada = systemqq('notepad mach2.s')

      chamada = systemqq('wgnuplot mach2.gnu')

      int4 = setexitqq(qwin$exitnopersist)
 
      END
 
!***********************************************************************
! *** DADOS ***
!              LE OS DADOS DO PROBLEMA
!***********************************************************************
      SUBROUTINE DADOS(ni,mi,me,gama)
      IMPLICIT REAL*8(A-H,O-Z)
	  real*8 mi,me
 
      READ(5,*) mi
      READ(5,*) me
      READ(5,*) ni
      READ(5,*) GAMA
 
      WRITE(6,35)
      WRITE(6,40) mi,me,ni,gama
 
   35 FORMAT(/,5X,'DADOS DE ENTRADA',/)
   40 FORMAT(3X,1PE17.9,' = Nmero de Mach inicial (adimensional)',/, &
             3X,1PE17.9,' = Nmero de Mach final (adimensional)',/, &
                 i6,14X,' = Nmero de pontos a calcular',/, &
             3X,1pe17.9,' = Razo entre os calores especficos (adim.)')
 
      END

!***********************************************************************
! *** PROPRIEDADES ***
!                     CALCULA A PRESSAO E TEMPERATURA ESTATICAS EM FUNCAO     
!                     DAS CONDICOES DE ESTAGNACAO E DO NUMERO DE MACH LOCAL
!***********************************************************************
      SUBROUTINE PROPRI(gama,M,te,pe,ue,ae)
      IMPLICIT REAL*8(A-H,O-Z)
      REAL*8 M
 
      EXP = GAMA / (GAMA - 1.0D0)
      exp2 = 0.5d0*(gama+1.0d0)/(gama-1.0d0)
      CTE = 1.0D0 + (GAMA - 1.0D0) * (M ** 2) / 2.0D0
      CE = 1.0D0 + (GAMA - 1.0D0) / 2.0D0
      Te = CE / cte
      Pe = (CE / cte) ** EXP
      ue = m * dsqrt(te)
      ae = ((2.0d0*cte/(gama+1.0d0))**exp2)/m
 
      END

